import cv2
# reading image
cap = cv2.VideoCapture(0, cv2.CAP_DSHOW)

# converting image into grayscale image

while (cap.isOpened()):
    #image pre-processing
    ret, RGBframe = cap.read()
    ratio = RGBframe.shape[0] / RGBframe.shape[1]

    gray = cv2.cvtColor(RGBframe, cv2.COLOR_BGR2GRAY)
    blurred = cv2.GaussianBlur(gray, (5, 5), 0)
    thresh = cv2.threshold(gray, 80, 300, cv2.THRESH_BINARY)[1]

    #contours
    contours, hierarchy = cv2.findContours(thresh, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
    #contours = imutils.grab_contours(contours)

    #print(len(hierarchy))

    for i in range(len(contours)):
        opened = hierarchy[0][i][2] < 0 and hierarchy[0][i][3] < 0
        for c in contours:
            approx = cv2.approxPolyDP(c, 0.03 * cv2.arcLength(c, True), True)
            x = approx.ravel()[0]
            y = approx.ravel()[1] - 5

            if(len(c) > 30):
                cv2.drawContours(RGBframe, [approx], 0, (0, 0, 0) if opened else (0, 0, 0), 1)

                if (len(approx) == 3):
                    cv2.putText(RGBframe, "triangle", (x, y), cv2.FONT_HERSHEY_COMPLEX, 0.5, (0, 0, 0))

                if (len(approx) == 4):
                    cv2.putText(RGBframe, "rectangle", (x, y), cv2.FONT_HERSHEY_COMPLEX, 0.5, (0, 0, 0))

                if (len(approx) > 5):
                    cv2.putText(RGBframe, "circle", (x, y), cv2.FONT_HERSHEY_COMPLEX, 0.5, (0, 0, 0))

    # displaying the image after drawing contours

    cv2.imshow("shape detection", RGBframe)
    if cv2.waitKey(10) & 0xFF == ord('q'):
        break

cap.release()
cv2.destroyAllWindows()




